
typedef  void( *ForEachUrlCallBack)(LPCWSTR url);


class MyParser : public IPropertyNotifySink, IOleClientSite, IDispatch
{
public:
	MyParser();
			
    ~MyParser();
   
	ForEachUrlCallBack forEachImage;
	ForEachUrlCallBack forEachLink;


	// IUnknown methods
    STDMETHOD(QueryInterface)(REFIID riid, LPVOID* ppv);
    STDMETHOD_(ULONG, AddRef)();
    STDMETHOD_(ULONG, Release)();

	// IPropertyNotifySink methods
    STDMETHOD(OnChanged)(DISPID dispID);
    STDMETHOD(OnRequestEdit)(DISPID dispID);

	// IOleClientSite methods
	STDMETHOD(SaveObject)(void) { return E_NOTIMPL; }

	STDMETHOD(GetMoniker)(DWORD dwAssign,
            DWORD dwWhichMoniker,
            IMoniker** ppmk)
			{  return E_NOTIMPL; }

	STDMETHOD(GetContainer)(IOleContainer** ppContainer)
			{  return E_NOTIMPL; }

	STDMETHOD(ShowObject)(void)
			{ return E_NOTIMPL; }

    STDMETHOD(OnShowWindow)(BOOL fShow)
			{  return E_NOTIMPL; }

    STDMETHOD(RequestNewObjectLayout)(void)
			{  return E_NOTIMPL; }

	// IDispatch method
	STDMETHOD(GetTypeInfoCount)(UINT* pctinfo)
			{  return E_NOTIMPL; }

	STDMETHOD(GetTypeInfo)(UINT iTInfo,
            LCID lcid,
            ITypeInfo** ppTInfo)
			{return E_NOTIMPL; }

	STDMETHOD(GetIDsOfNames)(REFIID riid,
            LPOLESTR* rgszNames,
            UINT cNames,
            LCID lcid,
            DISPID* rgDispId)
			{ return E_NOTIMPL; }

	STDMETHOD(Invoke)(DISPID dispIdMember,
            REFIID riid,
            LCID lcid,
            WORD wFlags,
            DISPPARAMS __RPC_FAR *pDispParams,
            VARIANT __RPC_FAR *pVarResult,
            EXCEPINFO __RPC_FAR *pExcepInfo,
            UINT __RPC_FAR *puArgErr);

	// Additional class methods
	//BOOL Init();

	BOOL parseUrl(LPCWSTR url, DWORD myUrlType, PUrlVector myPUrlVector);
	BOOL parseUrl(LPCWSTR url, DWORD myUrlType, UrlCallbackType myUrlCallback, LPVOID myUserData);
	BOOL parseUrl2(LPCWSTR url, DWORD myUrlType, UrlCallbackType myUrlCallback, LPVOID myUserData);

#if 0
	BOOL parseFile(LPCTSTR fileName)
	{
		if (SUCCEEDED(LoadURLFromFile(fileName)))
		{
			if (SUCCEEDED(Run()))
			{
				return TRUE;
			}
		}
		return FALSE;
	}



	BOOL parseBuffer2(LPBYTE buffer, DWORD size)
	{	
		if (myStream.init(buffer, size))
		{
			if (SUCCEEDED(LoadURLFromStream()))
			{
				return TRUE;
			}
		}
		return FALSE;
	}
	BOOL parseBuffer3(LPBYTE buffer, DWORD size)
	{
		/*
		if (CreatePointerMoniker(
			if (SUCCEEDED(LoadURLFromStorage()))
			{
				return TRUE;
			}
		}
		*/
		return FALSE;
	}
	
	HRESULT LoadURLFromStream()
	{
		HGLOBAL hMemory;
        hMemory = GlobalAlloc(GMEM_MOVEABLE, 0);
        if (hMemory != NULL)
        {
            CComQIPtr<IPersistStreamInit> spPersistStream = spDisp;
            if (spPersistStream != NULL)
            {
                CComPtr<IStream> spStream;
                if (SUCCEEDED(CreateStreamOnHGlobal(hMemory, TRUE, &spStream)))
                {
                    spPersistStream->Save(spStream, FALSE);

				}
			}
		}
	}
#endif

	BOOL doParseUrl2(LPCTSTR lpFileName);
	BOOL parseBuffer(LPBYTE buffer, DWORD size)
	{
		BOOL result = FALSE;
		HGLOBAL hGlobal = NULL;
		CComPtr<IStream> pStream = NULL;
		LPVOID pMem = NULL;
		if ((hGlobal = GlobalAlloc(GMEM_MOVEABLE, size)) != NULL)
		{
			if ((pMem = GlobalLock(hGlobal)) != NULL)
			{
				memcpy(pMem, buffer, size);
				if (SUCCEEDED(CreateStreamOnHGlobal(buffer, TRUE, &pStream)))
				{
					CComQIPtr<IPersistStreamInit> spPersistStream(m_pMSHTML);
					if (spPersistStream)
					{
						spPersistStream->InitNew();
						spPersistStream->Load(pStream);
						result = TRUE;
					}
				}
			}
		}
		return FALSE;
	}

	HRESULT WalkAll();
/*
	HRESULT Run();
	HRESULT Term();
	HRESULT Walk();
	HRESULT GetUA(BSTR* pbstrUA);
*/
	HRESULT GetUA(BSTR* pbstrUA);

protected:
	//CMyStream myStream;
	//IStream* pStream;
	// Persistence helpers
	HRESULT LoadURLFromFile(LPCTSTR fileName);
	bool LoadURLFromFile(LPCTSTR lpFileName, LPBYTE& lpBuffer, DWORD& dwSize);

	HRESULT LoadURLFromMoniker(LPCTSTR url);
	//HRESULT LoadURLFromStream();
	//HRESULT LoadURLFromStream2();
	//HRESULT LoadURLFromStorage();

	HRESULT doWalkAll(DWORD urlType);


	IHTMLDocument2* m_pMSHTML;
	DWORD m_dwRef;
	DWORD m_dwCookie;
	LPCONNECTIONPOINT m_pCP;
	//HRESULT m_hrConnected;
	LPCTSTR m_szURL;
	INTERNET_SCHEME m_nScheme;
	READYSTATE m_lReadyState;

	INTERNET_SCHEME GetScheme(LPCTSTR szURL);

	CWinSink* m_pWinSink;
	HANDLE m_event;
	BOOL   hasError;
	PUrlVector pUrlVector;
	UrlCallbackType urlCallback;
	DWORD urlTypes;
	DWORD parseType;
	LPVOID userData;

	BOOL doParseUrl(LPCWSTR url);

	void handleUrl(DWORD urlType, UrlStruct& urlStruct);
};